#include<bits/stdc++.h>
using namespace std;
int t,n,m;
long long raz,minraz;
long long a[100000],b[100000];
bool prov;
string s;
bool modulo(long long x,long long y, long long razlika)
{
    long long novi_broj=abs(x-y);/// a[i+1]-a[i]
    int cnt=0;
    long long temp=novi_broj;
    long long res=0;
    s.clear();
    while(temp!=0)
    {
        cnt++;
        temp/=10;
    }
    for(int i=0;i<cnt;i++)
    {
        s.push_back(novi_broj%10+48);
        novi_broj/=10;
    }
    for(int i=s.size()-1;i>=0;i--)
    {
        res=(res*10+(int)s[i]-'0')%razlika;
    }
    //cout<<res<<" "<<x<<" "<<y<<endl;
    if(res!=0)
    {
        return false;
    }
    return true;
}
int main()
{
    scanf("%d",&t);
    while(t--)
    {
        prov=true;
        scanf("%d %d",&n,&m);
        for(int i=1;i<=n;i++)
        {
            scanf("%lld",&a[i]);
        }
        sort(a+1,a+n+1);
        for(int j=1;j<=m;j++)
        {
            scanf("%lld",&b[j]);
        }
        raz=a[2]-a[1];
        for(int i=1;i<n;i++)
        {
            minraz=min((a[i+1]-a[i]),raz);
        }
        for(int i=1;i<n;i++)
        {
            if(!modulo(a[i+1],a[i],minraz))
            {
                prov=false;
                break;
            }
            /*if((a[i+1]-a[i])%minraz!=0)
            {
                prov=false;
                break;
            }
            */
        }
        if(!prov)
        {
            printf("0\n");
            continue;
        }
        for(int i=1;i<=m;i++)
        {
            if(modulo(a[n],b[i],minraz))
            {
                prov=false;
                break;
            }
            /*if(abs(a[n]-b[i])%minraz==0)
            {
                prov=false;
                break
            }
            */
        }
        if(!prov)
        {
            printf("0\n");
        }
        else
        {
            printf("1\n");
        }
    }
    return 0;
}